<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Izg project: stack/src/stack/stack.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Izg project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_ab51a11a65415835ab0b627ec1ba1885.html">stack</a></li><li class="navelem"><a class="el" href="dir_61f884239e7b9d662572355c29328680.html">src</a></li><li class="navelem"><a class="el" href="dir_7f90c3d965de0e82fe4c04904f65e6da.html">stack</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">stack.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="stack_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#pragma once</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include&lt;stdint.h&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include&lt;errorCodes/errorCodes.h&gt;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include&lt;stack/stack_export.h&gt;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div><div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="structStack.html">   17</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structStack.html">Stack</a>{</div><div class="line"><a name="l00018"></a><span class="lineno"><a class="line" href="structStack.html#ab477d1daabe17ea9a06bca917d31fa0b">   18</a></span>&#160;  <span class="keywordtype">void</span>*    <a class="code" href="structStack.html#ab477d1daabe17ea9a06bca917d31fa0b">values</a>     ;</div><div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="structStack.html#a67852b957af50a592ef664150864b69d">   19</a></span>&#160;  uint32_t <a class="code" href="structStack.html#a67852b957af50a592ef664150864b69d">reserved</a>   ;</div><div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="structStack.html#a7749b0e721f7bf75886e6474604a627f">   20</a></span>&#160;  uint32_t <a class="code" href="structStack.html#a7749b0e721f7bf75886e6474604a627f">size</a>       ;</div><div class="line"><a name="l00021"></a><span class="lineno"><a class="line" href="structStack.html#a30d2d941e3fe2500e7831a498e4b9645">   21</a></span>&#160;  uint32_t <a class="code" href="structStack.html#a30d2d941e3fe2500e7831a498e4b9645">elementSize</a>;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;};</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="stack_8h.html#acccdaeb94a63f3757825012007215c0d">   24</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="structStack.html">Stack</a> <a class="code" href="structStack.html">Stack</a>;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#ifdef __cplusplus</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;STACK_EXPORT <span class="keywordtype">void</span> <a class="code" href="stack_8h.html#a597cb5a7133e90d0417f04faba12336f">stack_init</a>(<a class="code" href="structStack.html">Stack</a>*<span class="keyword">const</span> stack,uint32_t <a class="code" href="structStack.html#a30d2d941e3fe2500e7831a498e4b9645">elementSize</a>);</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;STACK_EXPORT <span class="keywordtype">void</span> <a class="code" href="stack_8h.html#a7303fa944dbb7badfba5a793eefc1fac">stack_free</a>(<a class="code" href="structStack.html">Stack</a>*<span class="keyword">const</span> stack);</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;STACK_EXPORT <span class="keywordtype">int</span> <a class="code" href="stack_8h.html#ae547df08a9392b3e35f05f1e45b67027">stack_empty</a>(<a class="code" href="structStack.html">Stack</a> <span class="keyword">const</span>*<span class="keyword">const</span> stack);</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;STACK_EXPORT uint32_t <a class="code" href="stack_8h.html#a81a83ab7efd7c040d09b33bfa23736f7">stack_size</a>(<a class="code" href="structStack.html">Stack</a> <span class="keyword">const</span>*<span class="keyword">const</span> stack);</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;STACK_EXPORT uint32_t <a class="code" href="stack_8h.html#aa54375167ecc90e7fb833865a72f96ad">stack_elementSize</a>(<a class="code" href="structStack.html">Stack</a> <span class="keyword">const</span>*<span class="keyword">const</span> stack);</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;STACK_EXPORT ErrorCode <a class="code" href="stack_8h.html#a68b4d31591b5d6e13fa3631031cfa578">stack_push</a>(<a class="code" href="structStack.html">Stack</a>*<span class="keyword">const</span> stack,<span class="keywordtype">void</span> <span class="keyword">const</span>*<span class="keyword">const</span> value);</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;STACK_EXPORT ErrorCode <a class="code" href="stack_8h.html#a428f0932e2279be42f5e3afa1c740f66">stack_pop</a>(<a class="code" href="structStack.html">Stack</a>*<span class="keyword">const</span> stack,<span class="keywordtype">void</span>*<span class="keyword">const</span> value);</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;STACK_EXPORT <span class="keywordtype">void</span>* <a class="code" href="stack_8h.html#a19d52057db00f64ddf153532adf42756">stack_top</a>(<a class="code" href="structStack.html">Stack</a>*<span class="keyword">const</span> stack);</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;STACK_EXPORT <span class="keywordtype">void</span>* <a class="code" href="stack_8h.html#aa6bcd90d757e5fc6ff6f19f840134458">stack_at</a>(<a class="code" href="structStack.html">Stack</a> <span class="keyword">const</span>*<span class="keyword">const</span> stack,uint32_t i);</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;STACK_EXPORT <span class="keywordtype">int</span>   <a class="code" href="stack_8h.html#aad38a822e2bc5988e8df9e92aba16018">stack_contain</a>(<a class="code" href="structStack.html">Stack</a> <span class="keyword">const</span>*<span class="keyword">const</span> stack,<span class="keywordtype">void</span>*d);</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="preprocessor">#ifdef __cplusplus</span></div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;}</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="structStack_html_a7749b0e721f7bf75886e6474604a627f"><div class="ttname"><a href="structStack.html#a7749b0e721f7bf75886e6474604a627f">Stack::size</a></div><div class="ttdeci">uint32_t size</div><div class="ttdoc">number of elements in stack </div><div class="ttdef"><b>Definition:</b> stack.h:20</div></div>
<div class="ttc" id="stack_8h_html_a68b4d31591b5d6e13fa3631031cfa578"><div class="ttname"><a href="stack_8h.html#a68b4d31591b5d6e13fa3631031cfa578">stack_push</a></div><div class="ttdeci">STACK_EXPORT ErrorCode stack_push(Stack *const stack, void const *const value)</div><div class="ttdoc">This function pushes a new value to the stack. </div><div class="ttdef"><b>Definition:</b> stack.c:108</div></div>
<div class="ttc" id="stack_8h_html_aad38a822e2bc5988e8df9e92aba16018"><div class="ttname"><a href="stack_8h.html#aad38a822e2bc5988e8df9e92aba16018">stack_contain</a></div><div class="ttdeci">STACK_EXPORT int stack_contain(Stack const *const stack, void *d)</div><div class="ttdoc">This function check if stack contain a value. </div><div class="ttdef"><b>Definition:</b> stack.c:172</div></div>
<div class="ttc" id="structStack_html_a30d2d941e3fe2500e7831a498e4b9645"><div class="ttname"><a href="structStack.html#a30d2d941e3fe2500e7831a498e4b9645">Stack::elementSize</a></div><div class="ttdeci">uint32_t elementSize</div><div class="ttdoc">size of on element in bytes </div><div class="ttdef"><b>Definition:</b> stack.h:21</div></div>
<div class="ttc" id="stack_8h_html_a7303fa944dbb7badfba5a793eefc1fac"><div class="ttname"><a href="stack_8h.html#a7303fa944dbb7badfba5a793eefc1fac">stack_free</a></div><div class="ttdeci">STACK_EXPORT void stack_free(Stack *const stack)</div><div class="ttdoc">This function frees stack. </div><div class="ttdef"><b>Definition:</b> stack.c:33</div></div>
<div class="ttc" id="stack_8h_html_aa6bcd90d757e5fc6ff6f19f840134458"><div class="ttname"><a href="stack_8h.html#aa6bcd90d757e5fc6ff6f19f840134458">stack_at</a></div><div class="ttdeci">STACK_EXPORT void * stack_at(Stack const *const stack, uint32_t i)</div><div class="ttdoc">This function returns pointer to an element. </div><div class="ttdef"><b>Definition:</b> stack.c:158</div></div>
<div class="ttc" id="structStack_html_a67852b957af50a592ef664150864b69d"><div class="ttname"><a href="structStack.html#a67852b957af50a592ef664150864b69d">Stack::reserved</a></div><div class="ttdeci">uint32_t reserved</div><div class="ttdoc">reserved memory size in elements </div><div class="ttdef"><b>Definition:</b> stack.h:19</div></div>
<div class="ttc" id="stack_8h_html_a81a83ab7efd7c040d09b33bfa23736f7"><div class="ttname"><a href="stack_8h.html#a81a83ab7efd7c040d09b33bfa23736f7">stack_size</a></div><div class="ttdeci">STACK_EXPORT uint32_t stack_size(Stack const *const stack)</div><div class="ttdoc">This function returns the number of size in the stack. </div><div class="ttdef"><b>Definition:</b> stack.c:58</div></div>
<div class="ttc" id="stack_8h_html_a597cb5a7133e90d0417f04faba12336f"><div class="ttname"><a href="stack_8h.html#a597cb5a7133e90d0417f04faba12336f">stack_init</a></div><div class="ttdeci">STACK_EXPORT void stack_init(Stack *const stack, uint32_t elementSize)</div><div class="ttdoc">This function inits stack. </div><div class="ttdef"><b>Definition:</b> stack.c:19</div></div>
<div class="ttc" id="stack_8h_html_a19d52057db00f64ddf153532adf42756"><div class="ttname"><a href="stack_8h.html#a19d52057db00f64ddf153532adf42756">stack_top</a></div><div class="ttdeci">STACK_EXPORT void * stack_top(Stack *const stack)</div><div class="ttdoc">This function return pointer to the top of the stack - last element. </div><div class="ttdef"><b>Definition:</b> stack.c:144</div></div>
<div class="ttc" id="structStack_html_ab477d1daabe17ea9a06bca917d31fa0b"><div class="ttname"><a href="structStack.html#ab477d1daabe17ea9a06bca917d31fa0b">Stack::values</a></div><div class="ttdeci">void * values</div><div class="ttdoc">value on the stack </div><div class="ttdef"><b>Definition:</b> stack.h:18</div></div>
<div class="ttc" id="stack_8h_html_ae547df08a9392b3e35f05f1e45b67027"><div class="ttname"><a href="stack_8h.html#ae547df08a9392b3e35f05f1e45b67027">stack_empty</a></div><div class="ttdeci">STACK_EXPORT int stack_empty(Stack const *const stack)</div><div class="ttdoc">This function returns 1 if the stack is empty. </div><div class="ttdef"><b>Definition:</b> stack.c:46</div></div>
<div class="ttc" id="stack_8h_html_a428f0932e2279be42f5e3afa1c740f66"><div class="ttname"><a href="stack_8h.html#a428f0932e2279be42f5e3afa1c740f66">stack_pop</a></div><div class="ttdeci">STACK_EXPORT ErrorCode stack_pop(Stack *const stack, void *const value)</div><div class="ttdoc">This function pops size from the stack. </div><div class="ttdef"><b>Definition:</b> stack.c:128</div></div>
<div class="ttc" id="stack_8h_html_aa54375167ecc90e7fb833865a72f96ad"><div class="ttname"><a href="stack_8h.html#aa54375167ecc90e7fb833865a72f96ad">stack_elementSize</a></div><div class="ttdeci">STACK_EXPORT uint32_t stack_elementSize(Stack const *const stack)</div><div class="ttdoc">This function returns the element reserved in bytes. </div><div class="ttdef"><b>Definition:</b> stack.c:70</div></div>
<div class="ttc" id="structStack_html"><div class="ttname"><a href="structStack.html">Stack</a></div><div class="ttdoc">This struct represents simple uint32_t stack. </div><div class="ttdef"><b>Definition:</b> stack.h:17</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Apr 23 2019 13:21:21 for Izg project by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
